<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\DashboardService;

class DashboardController extends FMCrud{
   protected $DashboardService;

    public function __construct($crudService, $environment, DashboardService $DashboardService) {
        parent::__construct($crudService, $environment);
        $this->DashboardService = $DashboardService;
    }

  public function getDadosLimpezaFinalizada(DTO\Request $request, DTO\Response $response) {
      $params = $request->getParameters();

      $dadosLimpezaFinalizada = $this->DashboardService->getDadosLimpezaFinalizada($params['hierarchyUsersList']);
      $dtsVal = new DataSet('dados', $dadosLimpezaFinalizada);
      $response->addDataSet($dtsVal);
  }

  public function getDadosTarefaAtrasada(DTO\Request $request, DTO\Response $response) {
      $params = $request->getParameters();

      $dadosLimpezaFinalizada = $this->DashboardService->getDadosTarefaAtrasada($params['hierarchyUsersList']);
      $dtsVal = new DataSet('dados', $dadosLimpezaFinalizada);
      $response->addDataSet($dtsVal);
  }

  public function getDadosTarefaConcluida(DTO\Request $request, DTO\Response $response) {
      $params = $request->getParameters();

      $dadosLimpezaFinalizada = $this->DashboardService->getDadosTarefaConcluida($params['hierarchyUsersList']);
      $dtsVal = new DataSet('dados', $dadosLimpezaFinalizada);
      $response->addDataSet($dtsVal);
  }

  public function getDadosProgress(DTO\Request $request, DTO\Response $response) {
    $params = $request->getParameters();

    $dadosProgress = $this->DashboardService->getDadosProgress($params['hierarchyUsersList']);
    $dtsVal = new DataSet('dados', $dadosProgress);
    $response->addDataSet($dtsVal);
  }

  // requisição para retorno dos dados para o card (Ultimas Tarefas Realizadas) Dashboard Supervisor
  public function getDadosUltimasTarefas(DTO\Request $request, DTO\Response $response) {
    $param = $request->getParameters();
    $dadosChecagemLimpeza = $this->DashboardService->getDadosUltimasTarefas($param['param1'], $param['param2']);
    $dtsVal = new DataSet('dados', $dadosChecagemLimpeza);
    $response->addDataSet($dtsVal);
  }

  // requisição para retorno dos dados para o card (Resumo de Tarefas) Dashboard Supervisor(Tarefas Diárias)
  public function getDadosResumoTarefas(DTO\Request $request, DTO\Response $response) {
    $param = $request->getParameters();
    $dadosTarefaDiaria = $this->DashboardService->getDadosResumoTarefas($param['param1'], $param['param2']);
    $dtsVal = new DataSet('dados', $dadosTarefaDiaria);
    $response->addDataSet($dtsVal);
  }

  // requisição para retorno dos dados do grafico Tarefas Realizadas Dashboard Supervisor
  public function getDadosChartTarefas(DTO\Request $request, DTO\Response $response) {
    $param = $request->getParameters();

    $dadosTarefaDiaria = $this->DashboardService->getDadosChartTarefas($param['param']);
    $dtsVal = new DataSet('dados', $dadosTarefaDiaria);
    $response->addDataSet($dtsVal);
  }

  // requisição para retorno dos dados para o grafico Não Conformidades Dashboard Supervisor
  public function getDadosChartNaoConformidades(DTO\Request $request, DTO\Response $response) {
    $param = $request->getParameters();

    $dadosChartNaoConformidades = $this->DashboardService->getDadosChartNaoConformidades($param['param']);
    $dtsVal = new DataSet('dados', $dadosChartNaoConformidades);
    $response->addDataSet($dtsVal);
  }

  // requisição para retorno dos dados para grafico Progresso Diario Dashboard Supervisor(Tarefas Diárias)
  public function getDadosChartProgressoDiario(DTO\Request $request, DTO\Response $response) {
    $param = $request->getParameters();

    $dadosChartProgressoDiario = $this->DashboardService->getDadosChartProgressoDiario($param['hierarchyUsersList']);
    $dtsVal = new DataSet('dados', $dadosChartProgressoDiario);
    $response->addDataSet($dtsVal);
  }

  // ------ REQUISIÇÕES DA TELA DE DASHBOARD (GERENCIAL) ----------

  public function setActivities(DTO\Request $request, DTO\Response $response) {

    $activities = $this->DashboardService->setActivities();
    $dtsVal = new DataSet('act', $activities);
    $response->addDataSet($dtsVal);
  }

  public function getLocals(DTO\Request $request, DTO\Response $response) {

    $id = $request->getParameters();

    $locals = $this->DashboardService->getLocals($id);
    $dtsVal = new DataSet('locals', $locals);
    $response->addDataSet($dtsVal);
  }

  public function dataBaseChartBarUnconformities(DTO\Request $request, DTO\Response $response) {
      $parametro = $request->getParameters();

      $dbcb = $this->DashboardService->dataBaseChartBarUnconformities($parametro);
      $dtsVal = new DataSet('dbChartb', $dbcb);
      $response->addDataSet($dtsVal);
  }

  public function dataBaseChartPieClean(DTO\Request $request, DTO\Response $response) {
      $parametro = $request->getParameters();
      // debugApi([$parametro]);
      //dbcb = data base chart bar
      $dbcp = $this->DashboardService->dataBaseChartPieClean($parametro);
      $dtsVal = new DataSet('dbChartp', $dbcp);
      $response->addDataSet($dtsVal);
  }

  public function dataBaseChartPieUnit(DTO\Request $request, DTO\Response $response) {
      $parametro = $request->getParameters();

       // debugApi([$parametro]);

      $dbcp = $this->DashboardService->dataBaseChartPieUnit($parametro);
      $dtsVal = new DataSet('dbChartpu', $dbcp);
      $response->addDataSet($dtsVal);
  }

  public function dataBaseChartBarAvgTime(DTO\Request $request, DTO\Response $response) {
      $parametro = $request->getParameters();

       // debugApi([$parametro]);

      $dbcp = $this->DashboardService->dataBaseChartBarAvgTime($parametro);
      $dtsVal = new DataSet('dbAvgTime', $dbcp);
      $response->addDataSet($dtsVal);
  }

  public function latestReports(DTO\Request $request, DTO\Response $response) {

      $reports = $this->DashboardService->latestReports();
      $dtsVal = new DataSet('reports', $reports);
      $response->addDataSet($dtsVal);
  }
}
?>